
⍝ original WSTPN5 sources, in unicode with underlined characters

⍝ A̲B̲C̲D̲E̲F̲G̲H̲I̲J̲K̲L̲M̲N̲O̲P̲Q̲R̲S̲T̲U̲V̲W̲X̲Y̲Z̲
⍝ T̲N̲ S̲G̲ C̲C̲ L̲N̲ 

∇ABP
 SP0[0,⍵]: EI0 → ES0, P0
 RSP0[5,6]: ES0 → ES0, P0
 RA0[0,1]: ES0, A0 → EI1
 SP1[0,⍵]: EI1 → ES1, P1
 RSP1[5,6]: ES1 → ES1, P1
 RA1[0,1]: ES1, A1 → EI0
 RP0[0,1]: RI0, P0 → RR0
 AP0[0,2]: RR0 → RI1, A0
 rP0[0,1]: RI1, P0 → RR0
 RP1[0,1]: RI1, P1 → RR1
 AP1[0,2]: RR1 → RI0, A1
 rP1[0,1]: RI0, P1 → RR1
 Lp0[0,1]: P0 → 
 LA0[0,1]: A0 → 
 LP1[0,1]: P1 → 
 LA1[0,1]: A1 → 
 M0=EI0,RI0
∇

∇P ADDNEXT P̲                     
 ⍝ AJOUT NOUVEAU SUIVANT A UN ETAT
 S̲G̲[1 4 ;P; (,S̲G̲[2;P;])⍳TR]←P̲,REC
∇

∇B ← ALPHAS P;X                          
 ⍝ DONNE VECTEUR BORNES INF POUR ETATS P
 B ← 0⍴0
 →(0=X←S̲T̲[3;P])/0
 B ← I̲D̲[S̲T̲[2;P]+¯1+⍳X]
∇

∇B ← BETAS P;X                          
 ⍝ DONNE VECTEUR BORNES SUP POUR ETATS P
 B ← 0⍴0
 →(0=X←S̲T̲[3;P])/0
 B ← I̲D̲[S̲T̲[2;P]+X+¯1+⍳X]
∇

∇S ← E1 BETWEEN E2; E̲1; E̲2;X
 ⍝ POUR EXHIBER PLUS COURT CHEMIN ENTRE E1 ET E2
 X←E2
 →(∨/E1∊X)/END
 DEB: E̲1←USUCC E1
 E̲2←UPRED E2
 →(E̲1∊X)/END
 →(∧/(E̲1∊E1),E̲2∊E2)/NONE
 E1←E̲1
 E2←E̲2
 →DEB
 END: S←(E̲1∊E̲2)/E̲1
 →0
 NONE: S←⍳0
∇

∇BOUNDED;P;P̲;TR;M;M̲;A;A̲;B;B̲;C;C̲;L∆∆CPU;L∆∆CLASSES
 CLEARCONTEXT
 INITIME
 INICBOUND
 P̲←STEP0
 S̲K̲←,1
 →CHECKCONDITIONS/SUITE
 PAUSEMSG
 →0
 SUITE: ⍝ ENUMERATION DES ETATS DU RESEAU CHARGE.
 →(GOFROM 1)/LAB
 PAUSEMSG
 →0
 LAB:OKMSG
∇

∇K←BOUNDEDTEST NUMBER
 →(2 3 4 =NUMBER)/E2,E3,E4
 E1:→0,K←BOUNDED1
 E2:→0,K←BOUNDED2
 E3:→0,K←BOUNDED3
 E4:→0,K←BOUNDED4
∇

∇K←BOUNDED1;V;W
 ⍝ TEST DITO KARP AMD MILLER'S
 W←REDUC V←S̲T̲[1;PREDS]
 V←(M̲S̲[W;]∧.≤M̲)/W
 →(K←0=⍴V)/0
 →(K←0=⍴V←(M̲S̲[V;]∨.<M̲)/V)/0
 K←0,P̲,1↑V
∇

∇K←BOUNDED2;V;W;PR;A̲B̲C̲
 ⍝ M̲ ≥ M AND M̲ ≠ M AND D̲ = D
 W←REDUC V←S̲T̲[1;PR←PREDS]
 V←(M̲S̲[W;]∧.≤M̲)/W
 →(K←0=⍴V)/0
 →(K←0=⍴V←(M̲S̲[V;]∨.<M̲)/V)/0
 ⍝ V EST ENSEMBLE DE MARQUAGES AVEC M INFERIEURS
 ⍝ ABC DE MEME DIM EXISTE PARMI ETATS PREDS AVEC CES MARQUAGES ?
 →(K←0=⍴PR←(S̲T̲[1;PR]∊V)/PR)/0
 →(K←0=⍴PR←(S̲T̲[1;PR]=⍴A̲)/PR)/0
 ⍝ MEME ABC PARMI CES ETATS
 A̲B̲C̲←,A̲,B̲,C̲
 →(0=⍴A̲B̲C̲)/END
 W←S̲T̲[2;P]∘.+¯1+⍳⍴A̲B̲C̲
 W←((⍴PR),⍴A̲B̲C̲)⍴I̲D̲[,W]
 →(K←0=⍴PR←(W∧.=A̲B̲C̲)/PR)/0
 END:K←0,p,1↑PR
∇

∇K←BOUNDED3
 ⍝ AVEC SEUILS
 'TEST D''ARRET NIVEAU 3 NON ENCORE IMPLANTE'
 ⍝ L∆BOUNDEDTESTLEVEL←2
 L∆BOUNDEDNESSTEST←2
 K←BOUNDED2
∇

∇K←BOUNDED4
 ⍝
 'TEST D''ARRET NIVEAU 4 NON ENCORE IMPLANTE'
 ⍝ L∆BOUNDEDTESTLEVEL←2
 L∆BOUNDEDNESSTEST←2
 K←BOUNDED2
∇

∇R←BREACHSET C;R̲
 ⍝ CLASSES DEPUIS LESQUELLES L'UNE DES CLASSES DE C EST ACCESSIBLE
 ⍝ UTILISE LES CFCMS
 R←,C
 DEB:R̲←REDUC R,(C̲C̲ ∊(C̲C̲[R]≠0)/C̲C̲[R])/⍳⍴C̲C̲
 R̲←REDUC R̲,(∨/[2] S̲G̲[1;;]∊R)/⍳(⍴S̲G̲)[2]
 →(~(⍴R̲)=⍴R)/NEXT
 →0
 NEXT:R←R̲
 →DEB
∇

∇B←CBOUNDOVER LMT;X
 →(~B←(⍴S̲T̲)[2]≥L∆∆CLASSES)/0
 L∆∆CLASSES←L∆∆CLASSES+LMT
∇

∇P←CFCMSPENDANTES;C;I;E;S
 ⍝ DETERMINE CFCMS PENDANTES
 P←⍳0
 C←C[⍋C←REDUC (C̲C̲≠0)/C̲C̲]
 I←1
 DEB: →(I>⍴C)/0
 E←(C̲C̲=C[I])/⍳⍴C̲C̲
 S←(S≠0)/S←,S̲G̲[1;E;]
 →(∧/S∊E)/LAB
 I←I+1
 →DEB
 LAB:P←P,C[I]
 I←I+1
 →DEB
∇

∇K←CHECKBOUNDED;W
 →(K←1↑W←BOUNDEDTEST L∆BOUNDEDNESSTEST)/0
 'CLASS ',(⍕W[2]),' FAILED BOUNDEDNESS TEST ',(⍕L∆BOUNDEDNESSTEST),' COMPARE CLASS ',⍕W[3]
 K←SOWHATNOW
∇

∇K←CHECKCBOUND
 →(K←~CBOUNDOVER L∆CLASSES)/0
 'OVERFLOW NUMBER OF CLASSES'
 TELLSTATES
 K←SOWHATNOW
∇

∇L ← CHECKCFCMS P;I
 L←(⍴P)⍴0
 I←1
 DEB:→(I>⍴P)/0
 L[I]←∧/(⍳(⍴T̲N̲)[1])∊S̲G̲[2;(C̲C̲=P[I])/⍳⍴C̲C̲;]
 I←I+1
 →DEB
∇

∇K←CHECKCONDITIONS
 ⍝ CHECKS SPECIFIC CONDITIONS IN L∆CONDITIONS
 K←1
 →(0=⍴L∆CONDITIONS)/0
 →(K←⍎L∆CONDITIONS)/0
 'CONDITION ',L∆CONDITIONS, ' VIOLATED'
 K←SOWHATNOW
∇

∇K←CHECKTIME
 →(K←~TIMEOVER L∆CPU)/0
 'OVERFLOW CPU TIME'
 TELLTIME
 K←SOWHATNOW
∇

∇CLASS N
 ⍝ DITO CLASSES
 CLASSES N
∇

∇CLASSES V;I;M̲;M
 ⍝ LIST PARTIEL ETATS
 M←0 0 ⍴''
 I←1
 →(~'*'∊V)/LAB
 V←(('*'=1↑V)/'1'),V,('*'=¯1↑V)/⍕(⍴S̲T̲)[2]
 V[(V='*')/⍳⍴V]←' '
 V←⍎V
 V←V[1]+¯1+⍳1+V[2]-V[p1]
 →DEB
 LAB:V←,⍎V
 V←REDUC V[⍋V]
 DEB:→(I>⍴V)/FIN
 M̲←PRINTCLASS V[I]
 →(⎕PW≥1+(⍴M)[2]+(⍴M̲)[2])/SUITE
 ' '
 M
 M←0 0 ⍴''
 SUITE:M←M CONCAT2 ' ' CONCAT2 M̲
 I←I+1
 →DEB
 FIN:' '
 M
∇

∇CLEARCONTEXT
 T̲T̲←TIME
 M̲S̲←0 0⍴0
 S̲T̲←4 0⍴0
 S̲G̲←4 0 0⍴0
 I̲D̲←⍳0
 C̲C̲←⍳0
 S̲K̲←⍳0
 C̲G̲←2 0 0 ⍴0
∇

∇CLEARNET
 E̲S̲← 2 0 0⍴0
 I̲S̲←2 0 1 ⍴0
 M̲0←0⍴0
 P̲N̲←0 0⍴''
 T̲N̲←0 0⍴''
 N̲N̲←''
∇

∇T←T1 CONCAT T2
 ⍝ CONCATENE TABLEAUX A 3 PLANS SELON LIGNES.
 →((⍴T1)[3]>(⍴T2)[3])/SUP
 →((⍴T1)[3]=(⍴T2)[3])/EQ
 INF: T1←((⍳(⍴T2)[3])∊⍳(⍴T1)[3])\[3] T1
 →EQ
 SUP: T2←((⍳(⍴T1)[3])∊⍳(⍴T2)[3])\[3] T2
 EQ: T←T1,[2] T2
∇

∇T←T1 CONCAT1 T2
 ⍝ CONCATENE MATRICES SELON LIGNES
 T1←(¯2↑ 1 1 ,⍴T1)⍴,T1
 T2←(¯2↑ 1 1 ,⍴T2)⍴,T2
 →((⍴T1)[2]>(⍴T2)[2])/SUP
 →((⍴T1)[2]=(⍴T2)[2])/EQ
 INF: T1←((⍳(⍴T2)[2])∊⍳(⍴T1)[2])\[2] T1
 →EQ
 SUP: T2←((⍳(⍴T1)[2])∊⍳(⍴T2)[2])\[2] T2
 EQ:T←T1,[1] T2
∇

∇T←T1 CONCAT2 T2
 ⍝ CONCATENE MATRICES SELON COLONNES
 T1←(¯2↑ 1 1 ,⍴T1)⍴,T1
 T2←(¯2↑ 1 1 ,⍴T2)⍴,T2
 →((⍴T1)[1]>(⍴T2)[1])/SUP
 →((⍴T1)[1]=(⍴T2)[1])/EQ
 INF: T1←((⍳(⍴T2)[1])∊⍳(⍴T1)[1])\[1] T1
 →EQ
 SUP: T2←((⍳(⍴T1)[1])∊⍳(⍴T2)[1])\[1] T2
 EQ:T←T1,[2] T2
∇

∇W←CONTEXTSIZE
 W←(⍴I̲D̲)+(×/⍴M̲S̲)+(×/⍴S̲T̲)+/×/⍴S̲G̲)
∇

∇CONTINUE;P;P̲;TR;M;M̲;A;A̲;B;B̲;C;C̲;Q;L∆∆CPU;L∆∆CLASSES
 ⍝ POURSUIT L'ENUMERATION OU ARRETEE
 INITIME
 INICBOUND
 →(0=⍴S̲K̲)/LAB
 →(GOFROM ¯1↑S̲K̲)/LAB
 PAUSEMSG
 →0
 LAB:OKMSG
∇

∇S←E1 CPATH E2;E;X
 ⍝ EXTRACTS A C-PATH BETWEEN C-SETS E1 AND E2
 S←⍳0
 E←E1 BETWEEN E2
 →(0=⍴E)/0
 S←1↑(E1∊E)/E1
 E←(~E=S)/E
 DEB: →((¯1↑S)∊E2)/0
 X←1↑(E∊(,S̲G̲[1;¯1↑S;]≠0)/,S̲G̲[1;¯1↑S;])/E
 S←S,X
 E←(~E=X)E
 →DEB
∇

∇DT←DEADTRANSITIONS
 DT←(~(⍳(⍴T̲N̲)[1])∊S̲G̲[2;;])/⍳(⍴T̲N̲)[1]
∇

∇DEADTST1
 B1[0,0]: P1×2, P2 → PT1
 E1[5,5]: PT1 → P3, P4
 B2[0,0]: P3 → PT2
 E2[20,20]:PT2 → P5
 B3[0,0]: P4 → PT3
 E3[4,4]: PT3 → P6
 B4[0,0]: P5, P6 → PT4
 E4[3,3]: PT4  → P7, P2
 B5[0,0]: P7 → PT5
 E5[2,2]: PT5 → P1
 M0=P1(2),P2,P3
∇

∇DEADTST2
 ⍝ NON LIVE, PSEUDO LIVE, SOME DEAD TRANSITIONS
 B1[0,0]: P1×2, P2 → PT1
 E1[5,5]: PT1 → P3, P4
 B2[0,0]: P3 → PT2
 E2[20,20]:PT2 → P5
 B3[0,0]: P4 → PT3
 E3[4,4]: PT3 → P6
 B4[0,0]: P5, P6 → PT4
 E4[3,3]: PT4  → P7, P2
 B5[0,0]: P7 → PT5
 E5[2,2]: PT5 → P1
 V1: P100 → P101
 V2: P101 → P102
 V3: P102 → P100
 D1: P200 → P201
 D2: P201 → P200
 M0=P1(2),P2,P3,P100
∇

∇DELETENETS L
 ⍝ ERASES DEFINITIONS OF NETS IN L
 ⍝ UPDATES DIRECTORY OF NETS
 ERASES TABLEAUS OF NETS IN L
 ERASENETS L
 L ← N̲L̲ N̲R̲ L
 SYS∆NETS ← SYS∆NETS E̲L̲ L
 'DEFINITION(S) OF NET(S) ',(L̲N̲ L),' ERASED'
 L ← ⎕EX L
∇

∇DROPOLDNET;M
 ⍝ DROP COPY OF OLD NET o
 M ← R̲D̲ SYS∆VARSNETS
 M → ⎕EX M,[2]((⍴M)[1],1)⍴'0'
∇

∇ERASECONTEXT L;J;M
 ⍝ ERASE CONTEXTS OF NETS IN L
 M ← R̲D̲ SYS∆VARSANA
 L ← N̲L̲ N̲R̲ L
 J ← ⎕EX L
 'CONTEXT(S) OF NET(S) ',(L̲N̲  J/[1] L),' ERASED'
∇

∇ERASENETS L;J;M
 ⍝ ERASES TABLEAUS OF NETS IN L AND THEIR CONTEXTS
 ERASECONTEXT L
 M ← R̲D̲ SYS∆VARSNETS
 L ← N̲L̲ N̲R̲ L
 J ← ⎕EX L
 'NET(S) ',(L̲N̲ J/[1] L),' ERASED'
∇

∇EXEC MAT;I
 I ← 1
 DEB:→(I>(⍴MAT)[1])/0
 ⍎MAT[I;]
 I ← I+1
 →DEB
∇

∇PMD←FIND;X;W;E;A̲B̲C̲
 PMD←0 0 0
 ⍝ EXISTE CLASSE AVEC MEME MARQUAGE ?
 X←(M̲S̲∧.=M̲)/⍳(⍴M̲S̲)[1]
 PMD[2]←1↑X,0
 ⍝ EXISTE DOMAINE AVEC MEME NOMBRE DE VARIABLES ?
 E←REDUC(S̲T̲[3;]=⍴A̲)/S̲T̲[2;]
 E←(S̲T̲[3;]=⍴A̲)/S̲T̲[2;]
 →(0=⍴E)/0
 ⍝ EXISTE CLASSE AVEC MEME DOMAINE ?
 PMD[3]←1↑E,0
 A̲B̲C̲←A̲,B̲,,C̲
 →(0=⍴A̲B̲C̲)/0
 W←E∘.+¯1+⍳⍴A̲B̲C̲
 W←((⍴E),⍴A̲B̲C̲)⍴I̲D̲[,W]
 W←(W∧.=A̲B̲C̲)/E
 PMD[3]←1↑W,0
 →(0=⍴W)/0
 ⍝ EXISTE CLASSE AVEC MEME M ET D ?
 E←((⍉S̲T̲[1 2;])∧.=PMD[2 3])/⍳(⍴S̲T̲)[2]
 PMD[1]←1↑E,0
∇

∇FINDFIRABLE;KB;X
 ⍝ DETERMINE TIRABLES, CALCULE MINS, MAX ET MODIFIE T̲T̲
 MINS←A̲
 MAX←¯1
 →(0=⍴T̲T̲)/0
 X←(REDUC T̲T̲) ING T̲T̲
 →(∧/B̲<0)/LAB
 KB←(B̲≥0)/⍳⍴B̲
 MAX←⌊/B̲[KB]
 X←X∧(MINS≤MAX)∧∧/[1] C̲[KB;]≥0
 LAB:MINS←X/MINS
 T̲T̲←X/T̲T̲
∇

∇S←E1 FSEQ E2;T
 ⍝ SHORTEST FIRING SEQUENCE BETWEEN C-SETS E1 AND E2
 E1←⍎E1
 E2←⍎E2
 →(∨/(E1,E2)>(⍴S̲G̲)[2])/ERROR
 S←E1 CPATH E2
 →(0=⍴S)/NONE
 →((⍴S)>1)/LAB
 S←⍕S
 →0
 LAB:T←T̲N̲[TPATH S;]
 S←(⍕1↑S),' ',;L̲N̲ (((⍴T)[1],4)⍴' -> '),[2] T,[2](((⍴T)[1],1)⍴'/'),[2]⍕((⍴T)[1],1)⍴1↓S
 →0
 NONE:'NO SUCH SEQUENCE'
 S←''
 →0
 ERROR:'CLASSE(S) ',(⍕(~(E1,E2)∊⍳(⍴S̲T̲)[2])/E1,E2),' UNKNOWN'
 S←''
∇

∇C←GAMMAS P;X
 ⍝ DONNE MATRICE CONTRAINTES POUR ETAT P:
 C←0 0 ⍴0
 →(0=X←S̲T̲[3;P])/0
 C←(X,X)⍴I̲D̲[((2×X)+S̲T̲[2;P]+¯1)+⍳X×X]
∇

∇K←GOFROM P
 M←MAR P
 A←ALPHAS P
 B←BETAS P
 C←GAMMAS P
 FWD: ⍝ STEP FORWARD, FIRES IF ANY THE FIRST
 ⍝ NOT YET FIRED TRANSITION FROM STATE P.
 →(~K←CHECKTIME)/0
 →(~K←CHECKCBOUND)/0
 ⍝ FIND THE FIRST TR:
 TR←NEXT P
 ⍝ CHECKS IF ANY, IF NONE STEP BACK:
 →(0=⍴TR)/BKW
 ⍝ FIRING TR FROM P, FILLS P̲ WITH - INDEX STATE IF
 ⍝ REACHED STATE IS KNOWN, ITS STORAGE INDEX ELSE:
 P̲←STEP TR
 ⍝ IF STATE REACHED IS NEW, ENUMERATE FROM IT, ELSE
 ⍝ CARRY ON FROM THE CURRENT STATE:
 →(0≥P̲)/FWD
 S̲K̲←S̲K̲,P̲
 P←P̲
 M←M̲
 A←A̲
 B←B̲
 C←C̲
 →(~K←CHECKBOUNDED)/0
 →(~K←CHECKCONDITIONS)/0
 →(~K←CHECKTIME)/0
 →(~K←CHECKCBOUND)/0
 →FWD
 BKW: ⍝ STEPS BAK
 ⍝ CALLED WHEN ALL TRANSITIONS FIRABLE FROM
 ⍝ THE CURRENT STATE HAVE BEEN FIRED.
 S̲K̲←¯1↓S̲K̲
 →(0=⍴S̲K̲)/0
 P←¯1↑S̲K̲
 M←MAR P
 A←ALPHAS P
 B←BETAS P
 C←GAMMAS P
 →FWD
∇

∇HISTORY
 ⍝ A FAIRE
∇

∇IFIP83
 T1[4,9]: P1, P2×2 → P3, P4, P5  
 T2[0,2]: P4 → P2  
 T3[1,3]: P5 → P2  
 T4[0,2]: P3 → P3  
 T5[0,3]: P3 → P1  
 M0=P1(1),P2(2)  
∇

∇V←B1 IND B2;I;J;K
 ⍝ VECTEUR CAR. A DROITE DE B1 DANS B2
 V←(⍴B2)⍴0
 →((0=⍴B1)∨0=⍴B2)/0
 I←⍴V
 DEB:→(I≤0)/0
 K←B2[I]∊B1
 →(~K)/LAB
 V[I]←1
 J←B1⍳B2[I]
 B1←((J-1)↑B1),J↓B1
 LAB:I←I-1
 →DEB
∇

∇V←B1 ING B2;I;J;K
 ⍝ VECTEUR CAR. A GAUCHE DE B1 DANS B2
 V←(⍴B2)⍴0
 →((0=⍴B1)∨0=⍴B2)/0
 I←1
 DEB: →(I>⍴V)/0
 K←B2[I]∊B1
 →(~K)/LAB
 V[I]←1
 J←B1⍳B2[I]
 B1←((J-1)↑B1),J↓B1
 LAB:I←I+1
 →DEB
∇

∇INICBOUND
 L∆∆CLASSES←(⍴S̲T̲)[2]+L∆CLASSES
∇

∇INICHECK
 INITIME
 L∆∆CPU←L∆CPU
 L∆∆STATES←L∆STATES
∇

∇INITIME
 L∆∆CPU←(TIME-T̲T̲)+L∆CPU
∇

∇V←M IOTA N;G
 ⍝ INDEX DES LIGNES DE M DANS N OU ZERO
 D←(⍴M)[1]
 V←1+D+((⍳D)-1+D)⌊.×M∧.=⍉N
∇

∇LIBNETS
 ,(((⍴SYS∆NETS)[2]⍴1),0)\[2] SYS∆NETS
∇

∇LISTFNS;I;M;J
 ⎕PW ← 120
 J←' ABCDEFGHIJKLMNOPQRSTUVWXYZ∆A̲B̲C̲D̲E̲F̲G̲H̲I̲J̲K̲L̲M̲N̲O̲P̲Q̲R̲S̲T̲U̲V̲W̲X̲Y̲Z̲0123456789'
 J←TRI(⍴⎕NL 3)⍴J⍳(,⎕NL 3)
 I←1
 DEB: →(I>⍴J)/0
 M←⎕CR(⎕NL 3)[J[I];]
 ' '
 ' '
 (((⍴M)[1],1)⍴'['),[2](0 1↓⍕⍉(1,(⍴M)[1])⍴¯1+⍳(⍴M)[1]),[2](((⍴M)[1],4)⍴']   '),[2] M
 I←I+1
 →DEB
∇

∇LIVE;P;L
 ⍝ TROUVER DEADLOCKS TOTAUX
 P←TOTALDEADLOCKS
 →(0≠⍴P)/NO
 ⍝ TROUVER CFCMS PENDANTES
 P←CFCMSPENDANTES
 ⍝ TESTER PRESENCE DE TOUTES LES
 ⍝ TRANSITIONS DANS CHAQUE CFCM PENDANTE
 L←CHECKCFCMS P
 →(~∧/L)/NO
 'LIVE',((⍴P)>1)/': ',(⍕⍴P),' PENDING CFCMS'
 →CY
 NO:'NOT LIVE (USE LIVEDIAGNOSIS FOR MORE INFORMATION)'
 CY:((~∧/C̲C̲=1)/'NOT '),'CYCLIC'
∇

∇LIVEDIAGNOSIS;TD;DT;X;P;DTT;E;LT
 ' '
 'LIVENESS DIAGNOSIS:'
 '(USE PRINTCFCMS FOR MORE ABOUT CFCMS)'
 ' '
 ⍝ PRINTS LIVENESS DIAGNOSIS
 TD←TOTALDEADLOCKS
 →(0=⍴TD)/SUITE
 X←(⍴TD)>1
 'CLASS',(X/'ES'),' ',(⍕TD),(X/' ARE'),((~X)/' IS A'),' TOTAL DEADLOCK',X/'S'
 ' '
SUITE: DT←DEADTRANSITIONS
 ⍝ DTT← TRANSITIONS QUASI VIVANTES
 DTT←(~DTT∊DT)/DTT←⍳(⍴T̲N̲)[1]
 →(0≠⍴TD)/END
 X←CHECKCFCMS P←CFCMSPENDANTES
 P←(X=0)/P
 X←1
 LT←DTT
DEB:→(X>⍴P)/END0
 LT←(LT∊S̲G̲[2;(C̲C̲=P[X])/⍳⍴C̲C̲;])/LT
 X←X+1
 →DEB
END0:DTT←(~DTT∊LT)/DTT
 X←1<⍴LT
 →(0=⍴LT)/END
 'TRANSITION',(X/'S '),(L̲N̲ T̲N̲[LT;]),(X/' ARE '),((~X)/' IS '),'LIVE'
 ' '
END:X←1<⍴DT
 →(0=⍴DT)/END2
 'TRANSITION',(X/'S '),(L̲N̲ T̲N̲[DT;]),(X/' ARE '),((~X)/' IS '),'DEAD FROM THE INITIAL CLASS'
END2: ⍝ DTT CONTIENT TRANSITIONS NON VIVANTES MAIS QUASIVIVANTES
 X←1
 DEB2: →(X>⍴DTT)/0
 E←PDEADLOCKFOR DTT[X]
 'TRANSITION ',T̲N̲[DTT[X];],' IS DEAD FROM CLASS',((1<⍴,E)/'ES'),' ',⍕E
 X←X+1
 →DEB2
∇

∇LIVETST1
 ⍝ LIVE, 2 CFCMS
 T1: B → D  
 T2: B → E  
 T3: F,D → B,H,G  
 T4: F,E → B,H,I  
 T5: H,G,D → F,D  
 T6: H,E,I → F,E  
 M0=B,G,F,I
∇

∇LIVETST2
 ⍝ LIVE, 3 CFCMS
 T1:A→B
 T2:A→C
 T3:A→D
 T4:B,F,G→B,E
 T5:C,F,H→C,E
 T6:D,F,I→D,E
 T7:B,E→F,G,A;
 T8:C,E→F,H,A
 T9:D,E→F,I,A
 M0=A,E,G,H,I
∇

∇LIVETST3
 ⍝ LIVE, 2 CFCMS
 T11:B1→D1
 T21:B1→E1
 T31:D1,F1→B1,H1,G1
 T41:E1,F1→B1,H1,I1
 T51:D1,G1,H1→D1,F1
 T61:E1,I1,H1→E1,F1
 M0=B1,G1,I1,F1
∇

∇LIVETST4
 T11:B1→D1
 T21:B1→E1
 T31:D1,F1→B1,H1.G1
 T41:E1,F1→B1,H1,I1
 T51:D1,G1,H1→D1,F1
 T61:E1,I1,H1→E1,F1
 T1:A→B
 T2:A→C
 T3:A→D
 T4:B,F,G→B,E
 T5:C,F,H→C,E
 T6:D,F,I→D,E
 T7:B,E→F,G,A;
 T8:C,E→F,H,A
 T9:D,E→F,I,A
 M0=B1	,F1,G1,I1,A,G,E,H,I
∇

∇LOADCONTEXT NOM;MAT
 ⍝ CHARGE CONTEXTE RESEAU NOM
 LOADNET NOM
 MAT←SYS∆VARSANA,[2](SYS∆VARSANA)[1]⍴'←'
 MAT←MAT,[2](R̲D̲ SYS∆VARSANA),[2]((⍴SYS∆VARSANA)[1],NOM)⍴NOM←N̲R̲ NOM
 EXEC MAT
 'CONTEXT OF ',N̲N̲.' LOADED'
∇

∇LOADED
 N̲N̲,' LOADED'
 (⍕(⍴E̲S̲)[3]),' PLACES, ',(⍕(⍴E̲S̲)[2]),' TRANSITIONS'
∇

∇LOADMERGENET NOM
 'FUNCTION LOADMERGENET NOT YET IMPLEMENTED'
∇

∇LOADNET NOM;MAT
 CLEARCONTEXT
 MAT←SYS∆VARSNETS,[2](⍴SYS∆VARSNETS)[1]⍴'←'
 MAT←MAT,[2](R̲D̲ SYS∆VARSNETS),[2]((⍴SYS∆VARSNETS)[1],⍴NOM)⍴NOM←N̲R̲ NOM
 EXEC MAT
 N̲N̲←NOM
 NOM,' LOADED,'
 (⍕(⍴P̲N̲)[1]),' PLACES, ',(⍕(⍴T̲N̲)[1]),' TRANSITIONS.'
∇

∇V←M0DEF;J;K
 ⍝ BUILDS DEFINITION OF M̲0
 V←(M̲0≠0)/⍳⍴M̲0
 J←P̲N̲[V;]
 K←((⍴V),1)⍴M̲0[V]
 V←(K[;1]=1)/⍳(⍴K)[1]
 K←(((⍴K)[1],1)⍴'('),[2](⍕K),[2]((⍴K)[1],1)⍴')'
 K[V;]←' '
 V←J,[2] K,[2]((⍴K)[1],1)⍴','
 V←'M0= ',(V≠' ')/V←¯1↓,V
∇

∇C̲G̲←MAKECFCMSGRAPH;CC
 ⍝ MAKES GRAPH OFCFCMS
 ⍝ USES MAKECLASSES FROM BBAUTOMA PACKAGE
 CC←C̲C̲+(C̲C̲=0)×⍳⍴C̲C̲
 C̲G̲←(CC MAKECLASSES S̲G̲[2 1 ;;]) [2 1 ;;]
∇

∇M←C MAKECLASSES T̲G̲;V;T̲;S̲;J;N;T
 ⍝ C: VECTOR OF CLASSES.
 ⍝ RQ: LABELS NON TRAITES SI EXISTENT.
 M←T̲G̲
 →(∧/V←C=⍳⍴C)/0
 ⍝ CONVERSION INDEX ETATS:
 ⎕IO←0
 M[1;;]←(0,C)[M[1;;]]
 M[1;;]←(0,V\1+⍳+/V)[M[1;;]]
 ⎕IO←1
 ⍝
 T̲←S̲← 0 0 ⍴0
 J←⍳⍴C
 DEB:→(0=⍴J)/FIN
 V←(C=1↑J)/⍳⍴C
 J←(~J∊V)/J
 N←M[;V;]
 N←(2,×/1↓⍴N)⍴,N
 T←N[1;]≠0
 N←T/[2] N
 T←(N[1;]≠0)/N[1;]
 V←(⍳⍴T)∊T⍳T
 T̲←T̲ CONCAT1 V/N[1;]
 S̲←S̲ CONCAT1 V/N[2;]
 →DEB
 FIN:M←(2,⍴T̲)⍴(,T̲),,S̲
∇

∇K←MAKENET NOM;M;I;L
 K←1
 M← 1 0 ↓⎕CR NOM
 I←1
 DEB: →(I>(⍴M)[1])/END
 L←M[I;]       ⍝ with quotes
 L←(L≠'''')/L  ⍝ dropping quotes
 L←(L≠' ')/L   ⍝ dropping spaces
 I←I+1
 →('⍝'=1↑L,'⍝')/DEB
 →('→='∊L)/TRANS,MAR
 'LINE: ',L,' REJECTED'
 →DEB
 TRANS: ⍎'(T̲''',(''') B̲E̲ (P̲''|:' S̲U̲ ''') T̲O̲ P̲''|→' S̲U̲ L),''''
 →DEB
 MAR: ⍎'M̲A̲''',(3↓L),''''
 →DEB
 END:→(I>1)/0
 K←0
∇

∇M←MAR P
 ⍝ P: LISTE DE POINTEURS D'ETATS
 M←,M̲S̲[S̲T̲[1;P];]
∇

∇N←NETDEF;I
 ⍝ BUILDS DEFINITION OF NETLOADED
 N←N̲N̲
 I←1
 DEB:→(I>(⍴T̲N̲)[1])/END
 N←N CONCAT1 TRANSDEF I
 I←I+1
 →DEB
 END: N←N CONCAT1 M0DEF
∇

∇T←NEXT P
 ⍝ GIVES FIRST TRANSITION NOT YET FIRED FROM
 ⍝ STATE P (MAY BE EMPTY):
 T←(,(S̲G̲[1;P;]=0)∧S̲G̲[2;P;]≠0)/,S̲G̲[2;P;]
 →(0=⍴T)/0
 T←1↑T
∇

∇NODE N
 ⍝ DITO NODES
 NODES N
∇

∇NODES V;I
 ⍝ LIST PARTIEL ETATS
 I←1
 →(~'*'∊V)/LAB
 V←(('*'=1↑V)/'1'),V,('*'=¯1↑V)/⍕(⍴S̲T̲)[2]
 V[(V='*')/⍳⍴V]←' '
 V←⍎V
 V←V[1]+¯1+⍳1 +V[2]-V[1]
 →DEB
 LAB:V←,⍎V
 V←REDUC V[⍋V]
 DEB:→(I>⍴V)/0
 PRINTNODE V[I]
 I←I+1
 →DEB
∇

∇NODES2 V;I
 ⍝ LIST PARTIEL ETATS
 I←1
 →(~'*'∊V)/LAB
 V←(('*'=1↑V)/'1'),V,('*'=¯1↑V)/⍕(⍴C̲G̲)[2]
 V[(V='*')/⍳⍴V]←' '
 V←⍎V
 V←V[1]+¯1+⍳1 +V[2]-V[1]
 →DEB
 LAB:V←,⍎V
 V←REDUC V[⍋V]
 DEB:→(I>⍴V)/0
 PRINTNODE2 V[I]
 I←I+1
 →DEB
∇

∇NORMALIZE;A;B;C;XB
 ⍝ 13/10/83
 ⍝ CALCULE MINS ET MAXS EFFECTIFS
 XB←(B̲≥0)/⍳⍴B̲
 →(0=⍴XB)/END
 DEB:A←A̲
 B←B̲
 C←C̲
 SUBSTITUTE XB
 →(∨/A≠A̲)/DEB
 →(∨/B≠B̲)/DEB
 →(∨/,C≠C̲)/DEB
 END: C̲←C̲⌊B̲∘.-A̲
 XB←(B̲<0)/⍳⍴B̲
 C̲[XB;]←B̲[XB]∘.-A̲
 C̲←(¯1+⍳⍴B̲)⌽[2] C̲
 C̲[;1]←B̲-A̲
 C̲←(- ¯1+⍳B̲)⌽[2] C̲
∇

∇OKMSG
 'BOUNDED'
 (⍕(⍴S̲T̲)[2]),' STATE CLASSES'
 TELLTIME
∇

∇OPTIONS
 SETTIME
 SETCBOUND
 SETBOUNDEDNESSTEST
 SETCONDITIONS
∇

∇PATHO
 A:P1,P3→P3,P2
 B:P3,P2→P2,P4
 C:P2,P4→P4,P1,P5
 D:P4,P5→P3
 M0=P2(1),P4(1),p5(1)
∇

∇PATHO3
 A:P1×2,P2,P3→P3×3,P4
 B:P1,P2×2,P4→P3,P4×3
 C:P3×3,P4×3→P1×3.P2×3
 M0=P2(1),P4(1),P5(1)
∇

∇PAUSEMSG
 'ENUMERATION SUSPENDED, ENTER CONTINUE FOR MORE'
 (⍕(⍴S̲T̲)[2]),' CLASSES ENUMERATED SO FAR.'
 TELLTIME
∇

∇E̲←PDEADLOCKFOR T;E
 ⍝ COMPUTES PARTIAL DEADLOCK SET FOR TR. T
 ⍝ I.E. CLASSES FROM WHICH (OR FROM THE SUCC. OF) T IS NOT FIRABLE.
 ⍝ E: CLASSES DEPUIS LESQUELLES T EST TIRABLE
 E←(∨/[2] S̲G̲[2;;]=T)/⍳(⍴S̲G̲)[2]
 ⍝ E ← BACKWARD REACHSET OF E
 E←BREACHSET E
 ⍝ E̲ ← SUCCESSORS OF E NON IN E
 E̲←REDUC (,S̲G̲[1;E;]≠0)/,S̲G̲[1;E;]
 E̲←(~E̲∊E)/E̲
∇

∇PLACES
 ⎕PW C̲T̲ F̲L̲ P̲N̲
∇

∇P← PN PLDEF W
 P←((⍴W)⍴'×'),[2]⍕W
 P[(W[;1]=1)/⍳(⍴W)[1];]←' '
 P←¯1↓,PN,[2] P,[2](⍴W)⍴','
 P←(P≠' ')/P
∇

∇P←PREDS;X
 ⍝ CALCULE PREDECESSEURS DU SOMMET COURANT
 X←C̲C̲[S̲K̲]=0
 P←(X/S̲K̲),(C̲C̲∊C̲C̲[(~X)/S̲K̲])/⍳⍴C̲C̲
∇

∇PRINTCFCMS;CG;I;K;X;CC
 ⍝ PRINTS GRAPH OF CFCMS AND CFCMS
 ' '
 'GRAPH OF CFCMS:'
 CG←MAKECFCMSGRAPH
 NODES2⍕⍳(⍴CG)[2]
 ' '
 'CONTENTS OF CFCMS:'
 CC←REDUC((C̲C̲=0)×⍳⍴C̲C̲)+C̲C̲
 I←1
 DEB:→(I>⍴CC)/0
 K←CC[I]
 →(0=C̲C̲[K])/LAB
 K←(C̲C̲=CC[I])/⍳⍴C̲C̲
 LAB:X←(⍴,K)>1
 'G',(⍕I),' CONTAINS CLASS',(X/'ES'),' ',⍕,K
 I←I+1
 →DEB
∇

∇M←PRINTCLASS I;J
 ⍝ I EST INDEX CLASSE
 M←'CLASS C',((' '≠J)/J←⍕I),':'
 M←M CONCAT1 'M = ' CONCAT2(L∆PRINT-4) PRINTMAR I
 M←M CONCAT1 'I : ' CONCAT2(L∆PRINT-4) PRINTDOM I
∇

∇T←PRINTCLASSES
 ' '
 'LIST OF STATE CLASSES:'
 CLASSES⍕⍳(⍴S̲T̲)[2]
∇

∇M←F PRINTDOM I;J;K;L;A;B;C;T;V;NAM;W
 ⍝ AFFICHAGE DOMAINE
 A←ALPHAS I
 B←BETAS I
 C←GAMMAS I
 T←TS2 MAR I
 M← 0 0 ⍴''
 →(0=⍴A)/0
 ⍝ CALCUL INSTANTIATIONS
 V←+/[1] T∘.=REDUC T
 W←⍉(⍳J←⌈/V)∘.≤V
 W←(W≠0)/W←,W×V←(⍴W)⍴⍳J
 NAM←((J,1)⍴'.'),[2] R̲G̲⍕|(J,1)⍴⍳J
 NAM←' ' CONCAT1 1 0 ↓NAM
 NAM←R̲G̲(R̲D̲ T̲N̲[T;]),[2] R̲G̲ NAM[W;]
 ⍝ CONTRAINTES SIMPLES
 J←1
 DEB:→(J>⍴T)/DEB2
 L←N̲R̲(⍕A[J]),' ≤ ',NAM[J;],(¯1≠B[J])/' ≤ ',⍕B[J]
 ⍝ L←N̲R̲(⍕A[J]),' ≤ ',NAM[J;],(0≤B[J])/' ≤ ',⍕B[J]
 M←M CONCAT1 F C̲T̲ L
 J←J+1
 →DEB
 DEB2: ⍝ CONTRAINTES COMPLEXES
 K←,⍉(⍴C)⍴⍳⍴A
 K←K CONCAT1,(⍴C)⍴⍳⍴A
 V←~(B[K[1;]]<0)∨(B[K[1;]]-A[K[2;]])≤,C
 K←V/[2] K,[1],C
 J←1
 DEB3:→(J>(⍴K)[2])/0
 L←N̲R̲ NAM[K[1;J];],' - ',NAM[K[2;J];],' ≤ ',⍕K[3;J]
 M←M CONCAT1 F C̲T̲ L
 J←J+1
 →DEB3
∇

∇PRINTGRAPH
 ' '
 'GRAPH OF STATE CLASSES:'
 NODES⍕⍳(⍴S̲T̲)[2]
∇

∇V←F PRINTMAR J;K
 ⍝ AFFICHE MARQUAGE J
 J←MAR J
 V←R̲D̲ P̲N̲[(J≠0)/⍳⍴J;]
 J←(J≠0)/J
 K←(((⍴J),1)⍴'('),[2] R̲G̲⍕((⍴J),1)⍴J
 K←(R̲D̲ K),[2]((⍴J),1)⍴')'
 V←V,[2] R̲G̲ ((J>1)\[1] (J>1)/[1] K),[2]((⍴J),2)⍴', '
 V←F C̲T̲ ¯1↓N̲R̲,R̲G̲ V
∇

∇PRINTNETDEF
 ⍝ PRINTS DEFINITION OF NET LOADED
 'NET LOADED IS: '
 ' '
 NETDEF
∇

∇N←PRINTNODE I;REC;T;M;L;J
 N← 0 0⍴''
 →(I>1)/DEB
 →(0=⍴TS M̲0)/DEB
 REC←⌊/,I̲S̲[1;TS M̲0;]    ⍝ assumes shift enabled ...
 →(REC≤0)/DEB
 →(0=L∆SHIFT)/DEB       ⍝ REC is local, so unused in caller
 N←N CONCAT1 '→ (⍴=', (⍕REC),')/C1'
 DEB:→(I>(⍴S̲G̲)[2])/0
 L←⍳0
 J←1
 DEB1:→(J>(⍴S̲G̲)[3])/END1
 →(0=S̲G̲[2;I;J])/END1
 L←L,', (',(N̲R̲ T̲N̲[S̲G̲[2;I;J];]),'∊[',(⍕S̲G̲[3;I;J]),','
 L←L,((S̲T̲[4;I]≥0)/⍕S̲T̲[4;I]),((S̲T̲[4;I]<0)/'⍵'),']'
 L←L,')',((S̲G̲[4;I;J]≠0)/'/(⍴=',(⍕S̲G̲[4;I;J]),')'),'/?'
 →(0=S̲G̲[1;I;J])/E1
 L←(¯1↓L),'C',⍕S̲G̲[1;I;J]
 E1: J←J+1
 →DEB1
 END1: N←N CONCAT1 ⎕PW C̲T̲('C',(⍕I),' →'),1↓L
∇

∇N←PRINTNODE2 I;T;M;L;J
 N← 0 0⍴''
 →(I>(⍴CG)[2])/0
 L←⍳0
 J←1
 DEB1: →(J>(⍴CG)[3])/END1
 →(0=CG[2;I;J])/END1
 L←L,', ',(N̲R̲ T̲N̲[CG[2;I;J];]),'/G',⍕CG[1;I;J]
 J←J+1
 →DEB1
 END1:N←('G',(⍕I),' → ') CONCAT2(⎕PW-4+⍴⍕I) ct_,2↓L
∇

∇K←PSAFE
 ⍝ CHECKS PSAFENESS
 →(K←∧/M̲≤1)/0
 'CLASS ',(⍕P̲),' FAILED PSAFE CONDITION'
∇

∇RAMA
B1[0,0]:P1,P2→PT1
E1[5,5]:PT1→P3,P4
B2[0,0]:P3→PT2
E2[20,20]:PT2→P5
B3[0,0]:P4→PT3
E3[4.4]:PT3→P6
B4[0.0]:P5,P6→PT4
E4[3,3]:PT4→P7,P2
B5[0,0]:P7→PT5
E5[2,2]:PT5→P1
M0=P1,P2,P3'
∇

∇R←REACHSET C;R̲
 ⍝ CLASSES ACCESSIBLES DEPUIS C
 ⍝ UTILISE LES CFCMS
 R←,C
 DEB: R̲←REDUC R,(C̲C̲∊(C̲C̲[R]≠0)/C̲C̲[R])/⍳⍴C̲C̲
 R̲←REDUC R̲,((,S̲G̲[1;R̲;])≠0)/,S̲G̲[1;R̲;]
 →(~(⍴R̲)=⍴R)/NEXT
 →0
 NEXT:R←R̲
 →DEB
∇

∇READMERGENET NOM
 ⍝ READS DEF OF NET NOM AND MERGES WITH NET LOADED
 SAVEOLDNET
 CLEARCONTEXT
 →(~MAKENET NOM)/END
 SYS∆NETS←SYS∆NETS A̲L̲ NOM
 NOM,' MERGED WITH ',N̲N̲,' UNDER NAME: ',N̲N̲,NOM
 (⍕(⍴P̲N̲)[1]),' PLACES, ',(⍕(⍴T̲N̲)[1]),' TRANSITIONS.'
 'DEFINITION OF NET ',N̲N̲,NOM,' CAN BE SAVED USING SAVENETDEF'
 DROPOLDNET
 N̲N̲←N̲N̲,NOM
 →0
 END:'DEFINITION ABORTED'
 RESTAUREOLDNET
∇

∇READNET NOM
 CLEARCONTEXT
 CLEARNET
 →(~MAKENET NOM)/END
 NOM,' LOADED,'
 N̲N̲←NOM
 SYS∆NETS←SYS∆NETS A̲L̲ NOM
 (⍕(⍴P̲N̲)[1]),' PLACES, ',(⍕(⍴T̲N̲)[1]),' TRANSITIONS.'
 →0
 END:'DEFINITION ABORTED'
 CLEARNET
∇

∇RECALE;XB
 ⍝ CALCULE REC, MODIFIE A̲, B̲  ET C̲
 REC←0
 →(0=⍴A̲)/0
 REC←⌊/A̲
 →(REC≤0)/0
 A̲←A̲-REC
 XB←(B̲≥0)/⍳⍴B̲
 →(0=⍴XB)/END
 B̲[XB]←B̲[XB]-REC
 END:XB←(B̲<0)/⍳⍴B̲
 C̲[XB;]←B̲[XB]∘.-A̲
∇

∇V←REDUC E
 V←((⍳⍴E)∊E⍳E)/E
∇

∇R←REDUC2 L
 ⍝ REDUCTION MATRICE L (SUPPRIME LIGNES REPETEES)
 R←((⍳(⍴L)[1])∊L IOTA L)/[1] L
∇

∇RENAMENET NOM
 ⍝ RENAMES LOADED NET
 N̲N̲,' RENAMED ',NOM
 N̲N̲←NOM
∇

∇RESTAUREOLDNET;MAT
 MAT←SYS∆VARSNETS,[2]((⍴SYS∆VARSNETS)[1],1)⍴'←'
 MAT←MAT,[2](R̲D̲ SYS∆VARSNETS),[2]((⍴SYS∆VARSNETS)[1],1)⍴'0'
 EXEC MAT
 N̲N̲,' RESTAURED'
∇

∇SAVECONTEXT;MAT
 SAVENET
 MAT←(R̲D̲ SYS∆VARSANA),[2]((⍴SYS∆VARSANA)[1],⍴N̲N̲)⍴N̲N̲
 MAT←MAT,[2](((⍴MAT)[1],1)⍴'←'),[2] SYS∆VARSANA
 EXEC MAT
 'CONTEXT OF ',N̲N̲,' SAVED'
∇

∇SAVENET;MAT
 MAT←(R̲D̲ SYS∆VARSNETS),[2]((⍴SYS∆VARSNETS)[1],⍴N̲N̲)⍴N̲N̲
 MAT←MAT,[2](((⍴MAT)[1],1)⍴'←'),[2] SYS∆VARSNETS
 EXEC MAT
 N̲N̲,' SAVED'
 SAVENETDEF
∇

∇SAVEOLDNET;MAT
 ⍝ SAVE TEMPORARILY LOADED NET
 MAT←(R̲D̲ SYS∆VARSNETS),[2]((⍴SYS∆VARSNETS)[1],1)⍴'O̲'
 MAT←MAT,[2](((⍴MAT)[1],1)⍴'←'),[2] SYS∆VARSNETS
 EXEC MAT
∇

∇SETBOUNDEDNESSTEST;V
 ⍝ SETS L∆BOUNDEDNESSTEST
 V←'BOUNDEDNESS TEST IS ',(⍕L∆BOUNDEDNESSTEST),'; ENTER NEW VALUE (0≤v≤4) OR RETURN: '
 V←(⍴V)↓⍞,0/⍞←V
 →(0=⍴V)/0
 L∆BOUNDEDNESSTEST←1↑⍎V
∇

∇SETCBOUND;V
 ⍝ SETS L∆CLASSES
 V←'NUMBER OF CLASSES INCREMENT IS ',(⍕L∆CLASSES),'; ENTER NEW VALUE OR RETURN: '
 V←(⍴V)↓⍞,0/⍞←V
 →(0=⍴V)/0
 L∆CLASSES←1↑⍎V
∇

∇SETCONDITIONS;V;pw
 ⍝ SETS L∆CONDITIONS
 pw←⎕PW
 ⎕PW←256
 V←'CONDITION IS ',((0=⍴L∆CONDITIONS)/'EMPTY'),L∆CONDITIONS,'; ENTER NEW CONDITION (ONE OF TSAFE,PSAFE,EMPTY) OR RETURN: '
 V←(⍴V)↓⍞,0/⍞←V
 ⎕PW←pw
 →(0=⍴V)/0
 →((5=⍴V)∧∧/(5↑V='EMPTY'))/E1
 L∆CONDITIONS←V
 →0
 E1:L∆CONDITIONS←''
∇

∇SETTIME;V
 ⍝ SETS L∆CPU
 V←'CPU TIME INCREMENT IS ',(⍕L∆CPU),'; ENTER NEW VALUE OR RETURN: '
 V←(⍴V)↓⍞,0/⍞←V
 →(0=⍴V)/0
 L∆CPU←1↑⍎V
∇

∇B←SOWHATNOW;X
 X←29↓⍞,⍞←'CONTINUE (C) OR PAUSE (P) ?: '
 →(B←'C'=1↑X)/0
∇

∇p←STEP TR;T̲T̲;REC;PMD;MINS;MAX
 ⍝ TIR: CALCULE M̲, A̲, B̲, C̲ ET T̲T̲
 TIR
 ⍝ RECALE: CALCULE REC, MODFIE A̲, B̲ ET C̲
 RECALE
 ⍝ RECHERCHE CLASSE EGALE
 PMD←FIND
 →(PMD[1]≠0)/OLD
 ⍝ CALCULE MINS, MAX, MODIF T̲T̲
 FINDFIRABLE
 ⍝ STOCKAGE NOUVELLE CLASSE
 p←STORECLASS 1↓PMD
 P ADDNEXT P̲
 →END
 OLD: P ADDNEXT PMD[1]
 P̲←-PMD[1]
 END:P UPDATECFCM P̲
∇

∇P̲←STEP0;MINS;MAX;T̲T̲;REC
 ⍝ VALEURS PAR DEFAUT ET CALCUL T̲T̲
 A̲←0⍴0
 B̲←0⍴0
 C̲← 0 0⍴0
 M̲←M̲0
 MINS←⍳0
 MAX←¯1
 T̲T̲←TS2 M̲
 →(0=⍴T̲T̲)/ST0
 ⍝ CALCUL A,B,C INITIAUX ET RECALAGE
 A̲←,I̲S̲[1;T̲T̲;]
 B̲←,I̲S̲[2;T̲T̲;]
 C̲←B̲∘.-A̲
 ⍝ RECALAGE, CALCULE REC
 RECALE
 ⍝ CALCUL TIRABLES, MINS, MAX, T̲T̲
 FINDFIRABLE
 ST0: ⍝ STOCKAGE ETAT INITIAL
 P̲←STOREINITIALCLASS
 C̲C̲←,0
∇

∇P̲←STORECLASS MD
 ⍝ STORAGE CLASS
 →(0≠MD[1])/E1
 M̲S̲←M̲S̲,[1] M̲
 MD[1]←(⍴M̲S̲)[1]
 E1:→(0≠MD[2])/E2
 MD[2]←1+⍴I̲D̲
 I̲D̲←I̲D̲,A̲,B̲,,C̲
 E2:S̲T̲←S̲T̲,[2] MD,(⍴A̲),MAX
 S̲G̲←S̲G̲ CONCAT(4 1 ,(⍴T̲T̲))⍴((⍴T̲T̲) ⍴0),T̲T̲,MINS,(⍴T̲T̲)⍴0
 P̲←(⍴S̲T̲)[2]
∇

∇P̲←STOREINITIALCLASS
 S̲T̲← 4 1 ⍴ 1 1,(⍴A̲),MAX
 M̲S̲←(1,⍴M̲)⍴M̲
 S̲G̲←(4 1 , ⍴T̲T̲)⍴((⍴T̲T̲) ⍴0),T̲T̲,MINS,(⍴T̲T̲)⍴0
 I̲D̲←A̲,B̲,,C̲
 P̲←1
∇

∇SUBSTITUTE V;K;XB
 ⍝ SUBSTITUE VARS D'INDEX V DANS A̲, B̲ ET C̲
 ⍝ CONSERVE DIMENSIONS A̲, B̲ ET C̲
 XB←(B̲≥0)/⍳⍴B̲
 V←(V∊XB)/V
 DEB: →(0=⍴V)/0
 K←1↑V
 A̲←A̲⌈A̲[K]-,C̲[K;]
 B̲←B̲⌊B̲[K]+,C̲[;K]
 C̲[XB;]←C̲[XB;]⌊(,C̲[XB;K])∘.+,C̲[K;]
 V←1↓V
 →DEB
∇

∇TELLSTATES
 (⍕(⍴S̲T̲)[2]),' CLASSES ENUMERATED'
∇

∇TELLTIME
 'CPUT = ',(⍕TIME-T̲T̲),'S'
∇

∇TESTTB
 A[2,4]:P1→P2
 B[3,6]:P2→
 M0=P1(10)
∇

∇TESTTB2
 A[2,4]:→P
 B[3,6]:P→
∇

∇D←TIME
 D←⎕AI[2]÷1000
∇

∇B←TIMEOVER LMT;X
 →(~B←(TIME-T̲T̲)≥L∆∆CPU)/0
 L∆∆CPU←L∆∆CPU+LMT
∇

∇TIR;TSR;TSE;TT;X;XB;K;SUP
 ⍝ REMPLIT M̲,A̲,B̲,C̲,T̲T̲: TIRE TR  DEPUIS ETAT P
 ⍝ CALCUL NOUVEAU MARQUAGE ET TESTS
 M̲←(M-,E̲S̲[1;TR;])+,E̲S̲[2;TR;]
 A̲←0⍴0
 B̲←0⍴0
 C̲← 0 0 ⍴0
 ⍝ CALCUL NOUVELLEMENT SENSIBILISEES
 T̲T̲←TS2 M̲
 →(0=⍴T̲T̲)/0
 ⍝ CALCUL RESTANTES ET TEST
 TSR←TS2 M-,E̲S̲[1;TR;]
 →(0=⍴TSR)/E2
 TT←TS2 M
 ⍝ DECALAGE
 E3: XB←(B≥0)/⍳⍴B
 K←TT⍳TR
 SUP←S̲T̲[4;P]
 A̲←0⌈(SUP≥0)×((B[K]≥0)×,-C[K;])⌈A-SUP
 B̲←B
 C̲←C
 →(0=⍴XB)/E4
 B̲[XB]←(,C[XB;K])⌊B[XB]-A[K]
 C̲[XB;]←C[XB;]⌊B[XB]∘.-A
 →((⍴XB)=⍴A̲)/LAB2
 C̲[X;]←((⍴A̲)⍴¯1)[X←(B<0)/⍳⍴B]∘.-A̲
 LAB2:X←(⍴C̲)⍴1,(⍴A̲)⍴0
 C̲[XB;]←C̲[XB;]+X[XB;]×(B̲[XB]∘.-A̲)-C[XB;]
 ⍝ ELIMINATUON SORTANTES
 E4:SUBSTITUTE (~X←TSR IND TT)/⍳⍴TT
 A̲←X/A̲
 B̲←X/B̲
 C̲←X/[1] X/[2] C̲
 ⍝ NORMALISATION
 NORMALIZE
 ⍝ ADJONCTION ENTRANTES
 E2:X←TSR ING T̲T̲
 A̲←X\A̲
 B̲←X\B̲
 C̲←X\[1] X\[2] C̲
 TSE←(~X)/T̲T̲
 X←(~X)/⍳⍴X
 A̲[X]←,I̲S̲[1;TSE;]
 B̲[X]←,I̲S̲[2;TSE;]
 C̲[X;]←B̲[X]∘.-A̲
 C̲[;X]←B̲∘.-A̲[X]
 ⍝ CHECK POINT
∇

∇TD←TOTALDEADLOCKS
 TD←(∧/[2] S̲G̲[2;;]=0)/⍳(⍴S̲G̲)[2]
∇

∇F←TPATH C
 ⍝ FIRING SEQUENCE FOR C-PATH C
 F←(,S̲G̲[1;¯1↓C;]=⍉(⌽ ⍴S̲G̲[1;¯1↓S;])⍴1↓S)/,S̲G̲[2;¯1↓S;]
∇

∇T←TRANSDEF I
 ⍝ BUILDS DEFINITION OF TRANSITION I OF NET LOADED
 T←'[',(⍕I̲S̲[1;I;]),',',((I̲S̲[2;I;]<0)/'⍵'),((I̲S̲[2;I;]≥0)/⍕I̲S̲[2;I;]),']:'
 T←T̲N̲[I;],((I̲S̲[1;I;]≠0)∨I̲S̲[2;I;]≠¯1)/T
 T←(T≠' ')/T
 T←T,': ',((E̲S̲[1;I;]≠0)/[1] P̲N̲) PLDEF ⍉(E̲S̲[1;I;]≠0)/[2] E̲S̲[1;,I;]
 T←T,' → ',((E̲S̲[2;I;]≠0)/[1] P̲N̲) PLDEF ⍉(E̲S̲[2;I;]≠0)/[2] E̲S̲[2;,I;]
∇

∇TRANSITIONS
 ⎕PW C̲T̲ F̲L̲ P̲N̲
∇

∇X←TRI M;I
 ⍝ ORDONNE LIGNES, SENS CROISSANT.
 I←(⍴M)[2]
 X←⍳(⍴M)[1]
 DEB:→(0≥I←I-1)/0
 X←X[⍋M[X;I]]
 →DEB
∇

∇T←TS M
 ⍝ M EST UN VECTEUR
 T←(E̲S̲[1;;]∧.≤M)/⍳(⍴E̲S̲)[2]
∇

∇B←TS2 M;V;T 
 ⍝ BAG DES TRANSITIONS SENSEBILISEES
 B←⍳0
 T←TS M
 →(0=⍴T)/0
 V←E̲S̲[1;T;]
 M←(((⍴V)⍴M)×V≠0)+(⌈/M)×V=0
 V←⌊/[2]⌊M÷(V=0)+V
 B←T
 →(∧/V≤1)/0
 V←,⍉(((⌈/V),⍴T) ⍴T)×⍉V∘.≥⍳⌈/V
 B←(V≠0)/V
∇

∇K←TSAFE
 ⍝ CHECKS TSAFENESS
 →(K← ~∨/(2×E̲S̲[1;;])∧.≤M̲)/0
 'CLASS ',(⍕P̲),' FAILED TSAFE CONDITION'
∇

∇P UPDATECFCM P̲;I;V;W
 ⍝ CALCUL INCREMENTAL CFCMS
 →(P̲>0)/NEW
 P̲← -P̲
 →(P=P̲)/SAME
 ⍝ P̲ ANCIEN
 →(C̲C̲[P̲]=0)/LAB
 ⍝ P̲ APPARTIENT A UNE CFCM
 I←C̲C̲[S̲K̲]⍳C̲C̲[P̲]
 →GO
 LAB:I←S̲K̲⍳P̲
 GO: →(I>⍴S̲K̲)/0
 V←(I-1)↓S̲K̲
 W←C̲C̲[V]=0
 V←(W/V),(C̲C̲∊C̲C̲[(~W)/V])/⍳⍴C̲C̲
 C̲C̲[V]←⌊/V
 →0
 SAME:C̲C̲[(⍳⍴C̲C̲)⍳P]←P   ⍝ check P ...
 →0
 NEW:C̲C̲←C̲C̲,0
∇

∇S←UPRED E
 ⍝ E UNION PRED E DANS S̲G̲
 S←REDUC E,(∨/[2] S̲G̲[1;;]∊E)/⍳(⍴S̲G̲)[2]
∇

∇S←USUCC E
 ⍝ E UNION SUCC E DANS S̲G̲
 S←REDUC E,(,S̲G̲[1; E;]≠0)/,S̲G̲[1; E;]
∇

∇WRITENET
 ⍝ BUILDS AND SAVES DEFINITION OF NET
 ⍝ USEFUL WHEN NET IS BUILT USING MERGE
 'DEFINITION OF ',(⎕FX NETDEF),' SAVED'
 SYS∆NETS←SYS∆NETS E̲L̲((⍴N̲N̲),1)⍴N̲N̲
 SYS∆NETS←SYS∆NETS CONCAT1 N̲N̲
∇

∇ZUBEK
 BT1[0.0]:P3,P8→ PT1
 ET1[3,3]:PT1→P1.P9
 BT2[0.0]:P6,P7→PT2
 ET2[3,3]:PT2→P4,P8
 BT3[0,0]:P5,P1→PT3
 ET3[1,1]:PT3→P2,P6
 BT40.0]:P4→PT4
 ET4[3,3]:PT43→P5
 BT5[0,0]:P9→PT5
 ET5[4,4]:PT5→P7
 BT6[0,0]:P2→PT6
 ET6[2,2]:PT6→P3
 '0=P1,P5,P7
∇

∇R←L A̲L̲ L1
 ⍝ AJOUTE L1 A MATRICE L
 R←REDUC2 L CONCAT1 L1
∇

∇TM B̲E̲ ES;M;N;TN
 ⍝ UPDATE T̲N̲, E̲S̲, I̲S̲
 TN←TM[1;;]
 TN←(∨/[1] TN≠' ')/[2] TN
 M←T̲N̲ CONCAT1 TN
 TN←M[(-(⍴TN)[1])↑⍳(⍴M)[1];]
 T̲N̲←M[REDUC M IOTA M;]
 V←(⍳(⍴T̲N̲)[1])∊⍳(⍴E̲S̲)[2]
 E̲S̲←V\[2] E̲S̲
 I̲S̲←V\[2] I̲S̲
 V←T̲N̲ IOTA TN
 ES←(2,(⍴TN)[1],(⍴ES)[3])⍴(,((⍴TN)[1],(⍴ES)[3])⍴,ES[1;;]),,((⍴TN)[1],(⍴ES)[3])⍴,ES[2;;]
 E̲S̲[;V;]←E̲S̲[;V;]+ES
 I̲S̲[;V;]←(2,(⍴TM)[2],1)⍴⍎,TM[2 3 ;;],[3](2,(⍴TM)[2],1)⍴' '
 ⍝ CHECK POINT
∇

∇M←X C̲T̲ L;U;V
 ⍝ FORMATTE LIGNE EN MATRICE LARGEUR X,
 ⍝ L EST NORMALISEE.
 X←1⌈X
 M←(0,X)⍴''
 V←(¯1+(L=' ')/⍳⍴L),⍴L
 DEB:→(0=⍴L)/0
 U←(V≤X)/V
 U←(U≥0)/U
 →(0=⍴U)/LAB
 M←M,[1] X↑(U←¯1↑U)↑L
 L←(U+1)↓L
 V←V-U+1
 →DEB
 LAB:M←M,[1] X↑L
 L←X↓L
 V←V-X
 →DEB
∇

∇R←L E̲L̲ L1
 ⍝ SUPPRIME L1 DE MATRICE L
 R←L
 →((⍴L1)[2]>(⍴L)[2])/0
 L1←((⍳(⍴L)[2])∊⍳(⍴L1)[2])\[2] L1
 R←(~(⍳(L)[1])∊L IOTA L1)/[1] L
∇

∇L← L̲N̲ MAT
 ⍝ MATRICE DE NOMS → LISTE DE NOMS
 L←N̲R̲,MAT,[2](⍴MAT)[1]⍴' '
∇

∇M̲A̲ PV;M;V;K;PN
 ⍝ ANALYSE LEXICALE ET STOCKAGE MARQUAGE INITIAL.
 PV←(PV≠' ')/PV
 PV[(PV=',')/⍳⍴PV]←' '
 PV←N̲L̲ PV
 V←(∧/[2] PV≠'(')/⍳(⍴PV)[1]
 M←,PV
 M[(M∊'()')/⍳⍴M]←' '
 PV←(⍴PV)⍴M
 M←((⍴PV)[1],2)⍴' '
 M[V;2]←'1'
 PV←PV,[2] M
 M←S̲P̲ PV
 PN←M[1;;]
 PN←(∨/[1] PN≠' ')/[2] PN
 K←P̲N̲ CONCAT1 PN
 P̲N̲←K[REDUC K IOTA K;]
 PN←K[(-(⍴PN)[1])↑⍳(⍴K)[1];]
 K←(⍳(⍴P̲N̲)[1])∊⍳(⍴E̲S̲)[3]
 E̲S̲←K\[3] E̲S̲
 M̲0←K\M̲0
 K←P̲N̲ IOTA PN
 M̲0[K]←M̲0[K]+⍎L̲N̲ M[2;;]
∇

∇M←N̲L̲ L;DML;FML;DMW;FMW;X;N;W1;W2;U
 ⍝ FORMATTE LISTE DE MOTS SEPARES PAR UN BLANC EN
 ⍝ MATRICE AVEC UN MOT PAR LIGNE CALE A GAUCHE
 DML←((' ',L)=' ')/⍳⍴' ',L
 FML←(((L,' ')=' ')/⍳⍴L,' ')-1
 N←⍴DML
 X←⌈/U←1+FML-DML
 DMW←1+X×+¯1+⍳N
 FMW←U+DMW
 W1←(1+N×X)⍴0
 W1[DMW]←1
 W2←(1+N×X)⍴0
 W2[FMW]←1
 M←(N,X)⍴(¯1↓(+\W1)≠+\W2)\(L≠' ')/L
∇

∇S←N̲R̲ L
 ⍝ NORMALISE BLANCS.
 S←(∨\L≠' ')/L
 S←(⌽ ∨\⌽ S≠' ')/S
 L←S≠' '
 S←(L∨1↓1⌽ 1,L)/S
∇

∇M←P̲ PV;V
 ⍝ ANALYSE LEXICALE LISTE DE PLACES.
 PV←,PV
 M←2 0 0 ⍴''
 →(0=⍴PV)/0
 PV[(PV=',')/⍳⍴PV]←' '
 PV←N̲L̲ PV
 V←(∧/[2] PV≠'×')/⍳(⍴PV)[1]
 M←,PV
 M[(M='×')/⍳⍴M]←' '
 PV←(⍴PV)⍴M
 M←((⍴PV)[1],2)⍴' '
 M[V;2]←'1'
 PV←PV,[2] M
 M←S̲P̲ PV
 ⍝ CHECK POINT
∇

∇M←R̲D̲ T
 ⍝ RECALE MATRICE T A DROITE
 M←(-(⍴T)[2]-⌈/[2](T≠' ')×(⍴T)⍴⍳(⍴T)[2])⌽ [2] T
∇

∇M←R̲G̲ T
 ⍝ RECALE MATRICE T A GAUCHE
 M←(¯1+⌊/[2]((T=' ')×(⍴T)[2])+(T≠' ')×(⍴T)⍴⍳(⍴T)[2])⌽ [2] T
∇

∇T←S̲P̲ M
 ⍝ X MOTS PAR LIGNE DANS M;
 ⍝ T: TABLEAU A X PLANS AVEC MOTS SEPARES.
 T←N̲L̲ N̲R̲,M,[2]((⍴M)[1],1)⍴' '
 T← 2 1 3 ⍉ ((⍴M)[1],((⍴T)[1]÷(⍴M)[1]),(⍴T)[2])⍴T
∇

∇V←AB S̲U̲ L;A;B;X;Y
 ⍝ SUBSTITUTION, AB FORMAT '(A|B)'.
 V←AB ⍳ '|'
 A←(V-1)↑AB
 B←(V-⍴AB)↑AB
 Y←(∧/[1](¯1+⍳⍴B)⌽ B∘.=L)/⍳⍴L
 V←L
 →(0=⍴Y)/0
 V←⍳0
 DEB:→(0=⍴Y)/END
 X←¯1↑Y
 Y←¯1↓Y
 V←A,((⍴B)↓(¯1+X-⍴L)↑L),V
 L←(X-⍴L)↓L
 →DEB
 END:V←((X-1)↑L),V
∇

∇M←T̲ TV;V
 ⍝ ANALYSE LEXICALE LISTE DE TRANSITIONS.
 TV←,TV
 V←~(+\TV='[')-+\TV=']'
 V←V∧TV=','
 TV[V/⍳⍴TV]←' '
 TV←'¯1|⍵' S̲U̲ TV
 TV←N̲L̲ TV
 V←(∧/[2] TV≠'[')/⍳(⍴TV)[1]
 M←,TV
 M[(M∊'[,]')/⍳⍴M]←' '
 TV←(⍴TV)⍴M
 M←((⍴TV)[1],5)⍴' '
 M[V;]←((⍴V),5)⍴' 0 ¯1'
 TV←TV,[2] M
 M←S̲P̲ TV
 ⍝ CHECK POINT
∇

∇ES←N1 T̲O̲ N2;W1;W2;M;K
 ⍝ UPDATE P̲N̲, PRODUIT LIGNE DE ES
 W1←1↓⍎,'0 ',L̲N̲ N1[2;;]
 N1←N1[1;;]
 N1←(∨/[1] N1≠' ')/[2] N1
 W2←1↓⍎,'0 ',L̲N̲ N2[2;;]
 N2←N2[1;;]
 N2←(∨/[1] N2≠' ')/[2] N2
 M←P̲N̲ CONCAT1 N1 CONCAT1 N2
 N2←M[(-(⍴N2)[1])↑⍳(⍴M)[1];]
 N1←M[(⍴N1)[1]↑(-(⍴N1)[1]+(⍴N2)[1])↑⍳(⍴M)[1];]
 P̲N̲←M[REDUC M IOTA M;]
 E̲S̲←(K←(⍳(⍴P̲N̲)[1])∊⍳(⍴E̲S̲)[3])\[3] E̲S̲
 M̲0←K\M̲0
 ES←(2 1 ,(⍴P̲N̲)[1])⍴0
 ES[1;;P̲N̲ IOTA N1]←W1
 ES[2;;P̲N̲ IOTA N2]←W2
 ⍝ CHECK POINT
∇

